


; ******************* rutiny na I2C ****************

; ****************** nadsatavenie MCU a portov ***************
;	 banksel	TRISC
;        	MOVLW   	B'11111111'      ; vechny vvody PORTU C vstupy
;        	MOVWF   	TRISC
        
 ;       	MOVLW   	B'01100000'
 ;       	MOVWF   	 SSPCON2
;       	 MOVLW  	 0x10		; 400kHz pri 4MHz osc --- ; (Fosc / (4 * penosov rychlost)) - 1
  ;     	 MOVWF  	 SSPADD           ; nastaven rychlosti komunikacie (napr 0x06 400khz I2C pro krystal 10Mhz ) datashhhet SSPADD 
;       	 BCF     	SSPSTAT,CKE      ; nastaven specifikace I2C
;      	  BSF     	SSPSTAT,SMP      ; data jsou vzorkovna po odesln vstupnch dat
;       	 BCF     	STATUS,RP0       ; banka 0
;       	 MOVLW   	0x38
;       	 MOVWF  	 SSPCON           ; nastaven I2C master mode
 ;      	 BCF     	PIR1,PSPIF       ; vynulovat pznak ten-zpisu
;        	BCF    	 PIR1,SSPIF       ; vynulovat pznak dokonen
 ;       	BCF     	PIR2,BCLIF       ; vynulovat pznak kolize
 ;       	CLRF    	INTCON           ; dn peruen ani timery
        
        
        ; mazanie registrov dat
 ;       	clrf		dataI2C		
  ;     	 clrf		ee1

  ; ******************* nadstavenie adresy SLAVE 16 bit 2x A/D MCP3426  adresa je 208 (11010000) **************

I2C_citanie_CH0 
	
	movlw	b'11010000'	; nadstavenie adresy SLAVE I2C
 	movwf	adrslave	
 	
	movlw 	b'10001000'		; config prevodnka
	movwf	zapisdata
	call	I2C_zapis   
	
 			
    	call	I2C_citanie
    	
    	movfw	ee1		; uloenie nameranch hodnot A/D
    	movwf	AD1_HI
    	
    	movfw	ee2
    	movwf	AD1_LO
    	
    	clrf	ee1
    	clrf	ee2
    	
    	return
    	; ********************************
I2C_citanie_CH1 		;citanie A/D z druhho kanlu

	movlw	b'11010000'	; nadstavenie adresy SLAVE I2C
	movwf	adrslave	
 	
	movlw 	b'10101000'		; config prevodnka
	movwf	zapisdata
	call	I2C_zapis   

 		
    	call	I2C_citanie
   
    	movfw	ee1		; uloenie nameranch hodnot A/D
    	movwf	AD2_HI
    	
    	movfw	ee2
    	movwf	AD2_LO
    	
    	clrf	ee1
    	clrf	ee2
    	
    	return
    	; **************************************

I2C_citanie_CH2 		;citanie A/D z tretieho kanlu - teda 18bit A/D (MCP3421 namiesto MCP3425) tento A/D ide v 16 bit mde

	movlw	b'11010010'	; nadstavenie adresy SLAVE I2C
	movwf	adrslave	
 	
	movlw 	b'10001000'		; config prevodnka
	movwf	zapisdata
	call	I2C_zapis   
 	
 		
    	call	I2C_citanie
    	
    	movfw	ee1		; uloenie nameranch hodnot A/D
    	movwf	AD3_HI
    	
    	movfw	ee2
    	movwf	AD3_LO
    	
    	clrf	ee1
    	clrf	ee2
    	
    	return
    	
    	
 ; **************** I2C citanie ********
I2C_citanie	
	
       	nop
       	nop
    ;  ********* tato pauza plati len v tomto programe !!!! inak je zbitocna, pokial je medzi zapisom a citanim dodrzana sprvna pauza    	
    
	call	pauza15ms
	call	pauza15ms
	call	pauza15ms
	call	pauza15ms
	
	call	pauza15ms
	
	
	call	pauza15ms
	call	pauza15ms
	call	pauza15ms
;;	call	pauza15ms
	
;	call	pauza15ms
	
;	call	pauza15ms
;	call	pauza15ms
	

 
 ;
 
 
 
      	
    ; *********************************************************  	
      	
;	call	start_I2C		; zaciatok komunikacie I2C
	
;	call	start_I2C2
       	call	Dalsi_StartI2C
       	
      	call	AdresaI2C_read		; nadstavenie citania
       	; ************ nacitavanie jednotlivych registrov ****
    	call	Prijem_I2C		; nacitanie hodnotz z I2C
   	movfw	dataI2C
    	movwf	ee1
       	
     	call	Prijem_I2C		; nacitanie hodnotz z I2C
	movfw	dataI2C
    	movwf	ee2
    	
    	call	Prijem_I2C_koniec	; ukoncenie I2C --- no ACK;
    	movfw	dataI2C
    	movwf	ee3	
       	
       	; ******* koniec ************* 
       	
       	call	StopI2C			; koniec komunikacie I2C
       		
	return
 
 ; **********************    zapis dat do I2C  	 ******************
I2C_zapis	;	
	nop
	nop
	
  	call	start_I2C		; zaciatok komunikacie I2C
       	; ************** zapis  3xdata *************
       		; adresa zapisu sa nadstavi na zaciatku   
       		; a potom sa automaticky inkrementuje
 ;      	call	pauza50us
	call	Zapisdat_I2C		
   ;          	call	Zapisdat_I2C
   ;    	call	Zapisdat_I2C
       	
       	
       	; ************ koniec  I2C  ***************

  	
       	call	StopI2C			; koniec komunikacie I2C
       		
       	return
       	
       	
       	
; ******************************************************************
 ; **************************** *********************************
  
  ; ************** rutiny pre ovladanie I2C ******************		
       		
start_I2C	; S - start
   	banksel   	PIR2
   	bcf     	 	PIR2,BCLIF   ; vymazat priznak kolize
;StartI2C
  	 banksel  	 PIR1      
  	 bcf     	  	PIR1,SSPIF   ; vynulovat priznak dokonceni
  	 banksel  	SSPCON2
 	  bsf       	 	 SSPCON2,SEN   ; send i2c START [S] bit
  	 banksel   	PIR2
  	 btfsc   	   	PIR2,BCLIF   ; doslo ke kolizi
 	  goto       	start_I2C ;$-12      ; Ano - znova START I2C
;   return   
  	 banksel   	PIR1      ;
 	  btfss   		PIR1,SSPIF   ; donkoncen START?
 	  goto   		$-7         ; NE, tak pockat a testovat kolizi
 	  
 	  
;AdresaI2C write ---------------   adresa SLAVE zariadenia
  	 banksel   	PIR1      ; START odeslan, jinak bych sem nedosel
 	  bcf     	 	PIR1,SSPIF   ; vynulovat priznak operace
 	  banksel   	SSPBUF      ;
;  	 movlw  	 b'10100000'   ; adresa + WRITE do   -- 
	bcf		adrslave,0	; nadstavenie WRITE ( 0 LNB) --- R/W = 0
	movfw		adrslave		; adresa volaneho  slave zariadesnia I2C + WRITE  + read xxxxxxx0
  	 movwf   		SSPBUF      ; registru odesilani
 	  banksel   	PIR1      ; dokonceno ?
  	 btfss   		PIR1,SSPIF   ; vcetne ACK od cidla?
  	 goto  	 	$-1         ; NE, tak pockat a testovat a cekat
  	 
  	 return
  	 


   	
   ; *********** dalsi S pre citanie ****
Dalsi_StartI2C
  	 banksel   	PIR1      ; Data odeslana, jinak bych sem nedosel
  	 bcf     	 	PIR1,SSPIF   ; vynulovat priznak operace
  	 banksel   	SSPCON2      ;
  	 bsf      		SSPCON2,RSEN; opakovany START,
  	 banksel   	PIR1      ;
   	btfss   		PIR1,SSPIF   ; dokonceno ?
  	 goto  	 	$-1         ; NE, tak pockat a testovat a cekat
  	 return
  	 
start_I2C2	; S - start
   	banksel   	PIR2
   	bcf     	 	PIR2,BCLIF   ; vymazat priznak kolize
;StartI2C
  	 banksel  	 PIR1      
  	 bcf     	  	PIR1,SSPIF   ; vynulovat priznak dokonceni
  	 banksel  	SSPCON2
 	  bsf       	 	 SSPCON2,SEN   ; send i2c START [S] bit
  	 banksel   	PIR2
  	 btfsc   	   	PIR2,BCLIF   ; doslo ke kolizi
 	  goto       	start_I2C ;$-12      ; Ano - znova START I2C
;   return   
  	 banksel   	PIR1      ;
 	  btfss   		PIR1,SSPIF   ; donkoncen START?
 	  goto   		$-7         ; NE, tak pockat a testovat kolizi
 	  return
  	 
  	; ************** citanie **********
  	
AdresaI2C_read
  	 banksel   	PIR1      ; Data odeslana, jinak bych sem nedosel
  	 bcf      		PIR1,SSPIF   ; vynulovat priznak operace
   	banksel   	SSPBUF
 ; 	 movlw  	 b'10100001'   ; adresa + READ, cteni teploty 10100001
 	bsf		adrslave,0	; nadstavenie WRITE ( 1 LNB), R/W =1
	movfw		adrslave		; adresa volaneho  slave zariadesnia I2C + read xxxxxxx1 
  	 movwf   		SSPBUF      ; registru odesilani
   	banksel 	 	 PIR1      ; dokonceno ?
   	btfss   		PIR1,SSPIF   ; vcetne ACK od cidla?
   	goto  		 $-1         ; NE, tak pockat a testovat a cekat
   	
   	return
   	
Prijem_I2C
   	banksel   	PIR1      ; Data odeslana, jinak bych sem nedosel
   	bcf      		PIR1,SSPIF   ; vynulovat priznak operace
   	banksel   	SSPCON2      ;
  	 bsf      		SSPCON2,RCEN; zapnout prijem
  	 banksel   	PIR1      ;
  	 btfss  	 	PIR1,SSPIF   ; precteno?
   	goto   		$-1         ; NE, tak pockat a testovat a cekat
  	 bcf     	 	PIR1,SSPIF   ; vynulovat priznak operace
  	 banksel   	SSPBUF      ;
   	movf   		SSPBUF,w   ; precist  bufer
  	 movwf   		dataI2C    ; ulozene nacitane data z jedneho ciklu I2C
   	banksel   	PIR1      ; Data prectena, jinak bych sem nedosel
   	bcf      		PIR1,SSPIF   ; vynulovat priznak operace
   	banksel   	SSPCON2         
   	bcf     	 	SSPCON2,ACKDT   ; vyslat AKC
  	 bsf      		SSPCON2,ACKEN   ; nastavit odeslani ACK
;   btfss   SSPCON2,ACKEN   ; odeslan?
;   goto   $-1

   	banksel   	PIR1      ; dokonceno ?
   	btfss  	 	PIR1,SSPIF   ; vcetne ACK do cidla?
   	goto   		$-1         ; NE, tak pockat a testovat a cekat
   	
   	return
   	
Prijem_I2C_koniec
   	banksel   	PIR1      ; Data odeslana, jinak bych sem nedosel
   	bcf      		PIR1,SSPIF   ; vynulovat priznak operace
   	banksel   	SSPCON2      ;
  	 bsf      		SSPCON2,RCEN; zapnout prijem
  	 banksel   	PIR1      ;
  	 btfss  	 	PIR1,SSPIF   ; precteno?
   	goto   		$-1         ; NE, tak pockat a testovat a cekat
  	 bcf     	 	PIR1,SSPIF   ; vynulovat priznak operace
  	 banksel   	SSPBUF      ;
   	movf   		SSPBUF,w   ; precist  bufer
  	 movwf   		dataI2C    ; ulozene nacitane data z jedneho ciklu I2C
   	banksel   	PIR1      ; Data prectena, jinak bych sem nedosel
   	bcf      		PIR1,SSPIF   ; vynulovat priznak operace
   	banksel   	SSPCON2         
   	bsf     	 	SSPCON2,ACKDT   ; vyslat AKC
  	 bsf      		SSPCON2,ACKEN   ; nastavit odeslani ACK
;   btfss   SSPCON2,ACKEN   ; odeslan?
;   goto   $-1

  	banksel   	PIR1      ; dokonceno ?
	btfss  	 	PIR1,SSPIF   ; vcetne ACK do cidla?
	goto   		$-1         ; NE, tak pockat a testovat a cekat
   	
   	return
   
     	; ************* zapis ******************	

  
  	 
Zapisdat_I2C
 	 banksel   	PIR1      ;
 	  btfss   		PIR1,SSPIF   ; donkoncen START?
 	  goto   		$-1         ; NE, tak pockat a testovat kolizi
;AdresaI2C write
  	 banksel   	PIR1      ; START odeslan, jinak bych sem nedosel
 	  bcf      		PIR1,SSPIF   ; vynulovat priznak operace
 	  banksel   	SSPBUF      ;
  	 movfw   		zapisdata   ; data na WRITE do  I2C
  	 movwf   		SSPBUF      ; registru odesilani
 	  banksel   	PIR1      ; dokonceno ?
  	 btfss   		PIR1,SSPIF   ; vcetne ACK od cidla?
  	 goto   		$-1         ; NE, tak pockat a testovat a cekat	
  	 
  	 return
  	 
	; ************* ukoncenie komunikacie ***********
	
StopI2C
  	banksel   	PIR1      ; Data odeslana, jinak bych sem nedosel
   	bcf      		PIR1,SSPIF   ; vynulovat priznak operace
   	banksel   	SSPCON2
   	bsf      		SSPCON2,PEN   ; odeslat STOP
  	 banksel   	PIR1      
   	btfss   		PIR1,SSPIF      ; odeslan
  	 goto   		$-1            ; ne
  	 
   	return               	