;****************************************************************************
;PODPROGRAMY
;****************************************************************************
INILCD	CALL	pauza15ms		;doba 15 milisekund
	BCF	RS
;	BCF	RW
	CALL	B_OUT 		;port A vstup
 
	MOVLW	B'00000011'
	MOVWF	PORTB
	BSF	E			;1
	nop
	BCF	E
	CALL	pauza5ms 		;doba 4 milisekund

	BSF	E			;2
	nop
	BCF	E
	CALL	pauza1ms 		;doba 100 mikrosekund

	BSF	E			;3
	nop
	BCF	E
	
	CALL	pauza1ms 		;doba 100 mikrosekund
	MOVLW	B'00000010'		; 4 bit komunikacia 
	MOVWF	PORTB
	BSF	E
	nop
	BCF	E

	
				; ********* nadsatvenie LCD 
	
	CALL	pauza1ms 		;doba 100 mikrosekund
	MOVLW	28h
	CALL	WRPRI 		;4 komunikacia a dva riadky
	MOVLW	08h
	CALL	WRPRI 		;displej OFF
	MOVLW	0ch
	CALL	WRPRI 		;displej clear
	MOVLW	06h
	CALL	WRPRI 		;inkrementace, normlna operacia
	RETURN
;****************************** zapis zobrazovanych dat
WRDATA
	BANKSEL	TMP
	MOVWF	TMP 		;cslo prkazu alebo data do registra TMP
	CALL	B_OUT 		;portB ako vstup
	SWAPF	TMP,W 		;horne 4 bity do registra W

	andlw	b'00001111'	;nulovanie ovladacich bitov RS,RW,E	pov b'00001111'
	MOVWF	PORTB 		;zpis 4 hornych bitov do LCD
	BSF	RS 		;nastaven bitov RS a RW pre zpis prkazu
;	BCF	RW

	BSF	E
	nop
	nop
	BCF	E
	MOVFW	TMP 		;obsah registra TMP do registra W
	

	andlw	b'00001111'	;nulovanie ovladacich bitov RS,RW,E	pov b'00001111'

	bcf	TMP,5
	movf	TMP,w	
	MOVWF	PORTB 		;zpis dolnych 4 bitov do LCD
	BSF	RS 		;nastaven bitov RS a RW pre zpis prkazu
;	BCF	RW
	BSF	E
	nop
	nop
	BCF	E
; ****************************** rozne druhz cakaia na ukoncenie zapisu/citania **********

;	CALL	T_BF 		;testovnie bitu BF = 0 ukoncenie operacie
;	call	pauza5ms	;cakanie na ukoncenie operacie
	goto	testbit		;testovanie RS bitu zapis/citanie a podla toho cakanie
	return
	
;******************************* zapis prikazu *********************
WRPRI
	BANKSEL	TMP
	MOVWF	TMP 		;cslo prkazu alebo data do registra TMP
	CALL	B_OUT 		;portB ako vstup
	SWAPF	TMP,W 		;horne 4 bity do registra W
	

	andlw	b'00001111'	;nulovanie ovladacich bitov RS,RW,E	--- pov b'00001111'
	
	MOVWF	PORTB 		;zpis 4 hornych bitov do LCD
	BCF	RS 		;nastaven bitov RS a RW pre zpis prkazu
;	BCF	RW
	BSF	E
	nop
	BCF	E
	MOVFW	TMP 		;obsah registra TMP do registra W


	andlw	b'00001111'	;nulovanie ovladacich bitov RS,RW,E	--- pov b'00001111'	
	
	MOVWF	PORTB 		;zpis dolnych 4 bitov do LCD
	BCF	RS 		;nastaven bitov RS a RW pre zpis prkazu
;	BCF	RW
	BSF	E
	nop
	BCF	E
	
; ****************************** rozne druhz cakaia na ukoncenie zapisu/citania **********

;	CALL	T_BF 		;testovnie bitu BF = 0 ukoncene operacie
;	call	pauza1ms	;cakanie na ukoncenie operacie
	goto 	testbit		;testovanie RS bitu zapis/citanie a podla toho cakanie
	return
;************************* testovanie zapis/citanie	
	
testbit
	btfsc	RS		;pokud slo o zapis dat
	goto	wr2		;cekej 40 mikrosekund
;.............................................................
	movlw	01h		;pokud slo o instrukci Display
	subwf	TMP,W		;Clear, cekej 1.64 ms
	bz	wr3
	movlw	02h		;pokud slo o instrukci Home,
	subwf	TMP,W		;cekej 1.64 ms
	bz	wr3
	movlw	03h		;pokud slo o instrukci Home,
	subwf	TMP,W		;cekej 1.64 ms
	bz	wr3
;.............................................................
wr2	call	pauza1ms		;cekej 40 mikrosekund
	return
;.............................................................
wr3	call	pauza5ms		;cekej 1.6 ms
	
	RETURN
;*********************************************************************************************
;RDDATA	CALL	WRPRI 		;nastavenie citane adresy
;	CALL	B_IN 		;port B vstup		
;	BSF	RS
;	BSF	RW
;	BSF	E
;	MOVFW	PORTC
;	MOVWF	NUM 		;jedna polovica dat do registra NUM
;	SWAPF	NUM,F
;	BCF	E
;	MOVLW	B'11110000'
;	ANDWF	NUM,F 		;prava registra NUM
;	BSF	E
;	MOVFW	PORTC
;	MOVWF	NUM1
;	BCF	E
;	MOVLW	B'00001111'
;	ANDWF	NUM1,W
;	IORWF	NUM,F 		;druh polka dat do registra NUM
;	CALL	T_BF 		;cak koniec operace
;	RETURN
;----------------------------------------------------------------------------
;T_BF	BCF	RS 		;podprogram testuje koniec operacie (bit BF)
;	BSF	RW
;	CALL	B_IN 		;portB vstup (po ukoncen zase vstup)
;	BSF	E
;	MOVFW	PORTB
;	MOVWF	RBF
;	BCF	E
;	NOP
;	BSF	E
;	MOVFW	PORTB
;	MOVWF	RBF1
;	BCF	E
;	BTFSC	BFx 		;je bit BF=0 ? (0 = koniec operace)
;	GOTO	$-10 		;nie - testuj znova
;----------------------------------------------------------------------------
B_OUT	MOVLW	B'00000000' 	;PORTB vstup,   ........................ ???????? pin A4 vstup
	GOTO	$+2
B_IN	MOVLW	B'00001111' 	;PORTB vstup
	BANKSEL	TRISB	 	;banka 1
	MOVWF		TRISB 		;nastavenie portu B
	BANKSEL	PORTB 		;banka 0

	RETURN
	
	
; ******************* mazanie LCD ************************

LCDCLEAR

	movlw	b'00000001'
	call	WRPRI
	return
	




; ****************** LCD HOME ***********************

LCDHOME
	movlw	b'00000011'
	call	WRPRI
	return
	




