
; ******************************************************
;  ******** REGULACIA NA PEC s 16bit A/D ******************
; ******************************************************
;    RB<7,6> - ENKODER --- UZ NIKDY TO TAKTO NEZAPAJAT ---> problm s debuggciou !!!!!!!!!!!!!! - 
;
;
; 	RA0 	- ON/OFF 4.096 V ref
;	RA1	- Enkoder TLACITKO
;	RB<3,0> - DATA na LCD
;	RB4	 - RS  LCD
;	RB5	 - E   LCD
;	RB<7,6> - ENKODER --- UZ NIKDY TO TAKTO NEZAPAJAT ---> problm s debuggciou !!!!!!!!!!!!!!
;	RC1	 - vystup na regulaciu (PWM)
;	RC2	 - vystup na signal LED1 (PWM) - zenen
;	RC3  	-  I2C
;	RC4	- I2C

;	RD1	 - vystup na signal LED2 - erven




 ; ********************** 887 ***************
 
 		list	p=16f887,  R=DEC
		#include<p16f887.inc>
	
	
	
;*********************************************************

	errorlevel  -302,-306           
     	__CONFIG	_CONFIG1, _WDT_OFF & _PWRTE_ON & _MCLRE_ON & _CP_OFF & _CPD_OFF & _BOR_ON & _IESO_ON & _FCMEN_ON & _LVP_OFF&_DEBUG_ON 
	
	__CONFIG 	_CONFIG2, _BOR40V & _WRT_OFF
     
     
 ;***********************************************************
 
 ; ******************** premenne ben, prepisuj sa - jedna premenn m viacej nzvov (resistanciaPT100.inc) *****************
 
 	cblock	0x20

 	;******************************* registre pre LCD	
;	RBF			; register pre test ukoncenia operacie BF
;	RBF1	
	NUM			; register pre citanie 4 bit D4/7
	NUM1	
	TMP	
 	
 	
; ******************************** prevod BID_DEC

	TEMPH
	TEMPL
	TEMPNM
	TEMPDP
	
	 CISLA1
	 CISLA10
	 CISLA100
	 
	 TMP_H
	 
; ************************** DIF - odstranenie zakmitov

;	A1d	;nov hodnota
;	A2d
;	B1d	;star hodnota
;	B2d
;	C1d	; pomocne cislo
;	C2d
	
	
	; ***************** I2C registre ********
       
       	adrslave		; adresa volaneho  slave zariadesnia I2C   ......   b'10100000'
       	adrslavedata	; adresa ukladanych/citanych dat v slave I2C
       	dataI2C		; ulozene nacitane data z I2C
       	zapisdata		; data na zapis do I2C
       	
       		; registre pre natane hodnoty 16bit  A/D po jednotlivch idlch
       	AD1_HI     
      	AD1_LO
       	
       	AD2_HI
       	AD2_LO
       	
       	AD3_HI
       	AD3_LO
       	
       	ee1		;pomocne prenenn pre A/D
       	ee2
       	ee3
       	; *********************** PT100 ************
       	
  
       	
  ;	hi_addr
       	; ***************** pomocn registre veobecn ****
       	
       	c
       	cc
       	ccc
       	
       	
; *************** pauza ************


	d1
	d2
	d3
	
		 ; premenn na zobrazenie v  LCD  
        	stovky                  ;each digit        
        	desiatky        
        	jednotky        
       	desatiny  
       	stotiny 
       	tisiciny
       	           
    	digit_count             ;counter used to cycle through each digit 
    	
    	LCDkz
    	CISLA01
    	 ; ********************* konvert ASCII/ BIN **************************
    	 
    	 DIGIT1			; vstupy
    	 DIGIT2
    	 DIGIT3
    	 
    	 COUNTN
    	 
    	 OUT			; vystup
    	 
  
	endc
	
	;  ; ******************* matematika  FLOAT doleit premenn a kontanty, ktor sa nebud prepisova v inch rutinch  ********** **
	;  ; ************************************************************************************************************
	cblock	0x57
	x1	;  float Uref / 65535
	x2	
	x3
    	x4
   	
   
   	Iref1		; I na idlch PT100
   	Iref2
   	Iref3
   	Iref4
   	
	R1		; ref odpor R=100 ohm +/- 0,02
	; ***************** premenn pre DIF merania na PT100
	R21		; odpor prvho idla PT100
	R22
	R23
	R24

	R31		; odpor druhho idla PT100
	R32
	R33
	R34
	
	cx		; opakovanie stabilizanch meran	
	cxLCD		;adresa na LCD pri stabilizanch meraniach
	MAX		;MAXteplota
	MAX_t		; MAX teplota na vpoty
	
	OUT_t1			;vystup pomocn pre porovnanie najvyej teploty na regulciu PWM
    	OUT_t2	
    	endc
    	; ************* premenn na kalibrciu ***************
AD1_11		equ	0x7c
AD1_12		equ	0x71
AD1_13		equ	0x73
AD1_14		equ	0x74


	; *********************************************
	 ; ***************** prerusenie
 	cblock	0x75
	 	; *********************** registre pre eeprom
 
 	EEEADR			;adresa eeprom pre zapis/citanie eeprom --- pozor pri citani sa pouziva  reg EEADR a nie EEEADR !!!!!
	EEEDATA			;data na zapis/citanie eeprom 
	
		; registre pre  PWM a test PWM 
		
	STO_test
	DESIAT_test
	JEDNA_test
		
	; ***********************  hyster **************
		
   	cccON			; register pre as zapnutia MAX vkonu
		
	cccOFF			; register pre as vypnutia MAX vkonu
		
	
 	endc
	;  ; ************************************************************************************************************
	;  ; ************************************************************************************************************

#define	Azn	FL,7		;znamnko A, 0=kladn 1=zporn
#define	Bzn	FL,6		;znamnko B, 0=kladn 1=zporn
	
	
last_digit set tisiciny
SIG_FIG equ     6               ;set SIG_FIG equal to the number of 
                                ;significant figures in your decimal number
                                ;for example: ones, tenths,hundredths, 
                                ;thousandths, requires 4 sig figs
	
	;********************************** LCD  ***************	

	#define   D4	PORTB,0		;4bit komunikacia LCD
	#define	D5	PORTB,1
	#define	D6	PORTB,2
	#define	D7	PORTB,3

	#define	RS	PORTB,4		;register 0 = instrukcie, 1 = data
	#define	E	PORTB,5		; E = 1/0 zac/kon zapisu/citania
;	#define  RW	PORTB,6		; RW = 0 zapis, RW = 1 citanie
	

	 ; *********** zaiatok programu ***************
        
       	org     0x0000

;
	goto	program
	
	  ; ********************* prerusenie od RB4/7 *******************
	; ********************************************************
	; ************* rutina obsluhy prerusenia **********************
	; ********************************************************
;	ORG	0x0004			;  C9
	

;prerusenie
 ;ulozenie zaloh registrov
 	
;	movwf	W_tmp		; W 
;	movfw	STATUS
;	movwf	Sta_tmp		; STATU
;	clrf	STATUS		; Banka 0S
;	movfw	PCLATH		; PCLATH
;	movwf	PCLATH_tmp
		
;	movfw	FSR
;	movwf	FSR_tmp		; FSR	
		
;
;	banksel	INTCON
;	bcf	INTCON,RBIF	; mazanie priznaku prerusenia na RB7 !!!!
		; ************* zakazanie  prerusenia **************
;	bcf	INTCON,RBIE		; zakazanie prerusenia od RB

 	; *********** test  RB7 -  ci je ozaj zopnut, odstranenie rusenia
;	call 	pauza5ms	; odstranenie rusenia na zbernici
;	bcf	PORTB,7
	
;	pagesel	program
	
;	btfss	PORTB,7	
;	goto	$-2
	; ******************************************	
	; program prerusenia, nadstavenie max teploty
	; ****************************************
	
;	pagesel	prerus 
;	call	prerus
	
; ***********************************************	
	
;koniec	
;	bcf	INTCON,RBIF	; mazanie priznaku prerusenia na RB7 !!!!
;	bsf	INTCON,RBIE		; povolene prerusenia od RB
;	bsf	INTCON,GIE	; povolenie prerusenia


;	movfw	FSR_tmp		; FSR
;	movwf	FSR
;	movfw	PCLATH_tmp		; PCLATH
;	movwf	PCLATH

;	movfw	Sta_tmp		; Status
;	movwf	STATUS
;	swapf	W_tmp,f	   	; W
;	swapf	W_tmp,w
	

	
	
;	return
   	     


	;; *************** podprogramy

	include	"LCDinic.inc"		; inicializacia + ovladanie LCD 2x20 ( zapis - citanie)
	include	"pauza.inc"		; cakacie doby 
	include	"zobraz.inc"		; hlsenai na LCD
	include	"I2C.inc"		; rutiny na obsluhu I2C
;	include	"I2C_factory_adr.inc"	; rutina na zistenei adresy I2C SLAVE zariadenia
;	include	"vypoctyLCD.inc"		; vypocty pre zobrazenia na   LCD
	include	"math_float.inc"		; vypocty pre desatinne cisla
	include	"math16_float.inc"	; desatinne cisla registre
	include	"math_floatFP32.inc"	; desatinne cisla rutina + - / * na 32bit;
;	include	"math_floatFP24.inc"	; desatinne cisla rutina + - / * na 24bit
;	include	"floasc.inc"		; prevod 32bit float na ASCII pre LCD
	include	"fxd26.inc"		
	



; ******************************************************
; ****************** samotn program **********************
;*******************************************************
;
	
program
 	banksel	PORTA		;port A
	clrf	PORTA

	banksel	TRISA
	
	
	clrf 	TRISA		; RA vsetko OUT
	bsf	TRISA,1
	

	BCF 	STATUS, RP0 	;registrova sada 0
	
	banksel		ADCON0
	MOVLW 	b'00000000' 		; all pin digital
	MOVWF	ADCON0
	
	
	banksel	PORTB		;port B
	clrf	PORTB

	banksel	TRISB
	clrf	TRISB
	bsf	TRISB,7		; enkoder
	bsf	TRISB,6		; enkoder
	
	bcf	WPUB,6			; pull up
	bcf	WPUB,7
	

	banksel	PORTC		;port C
	clrf	PORTC

	banksel	TRISC
	clrf	TRISC
	
;	banksel	PORTD		;port D
;	clrf	PORTD

	banksel	TRISD
	clrf	TRISD

	banksel	PORTE		;port E
	clrf	PORTE

	banksel	TRISE
	clrf	TRISE

	bsf	TRISE,0		; R/S
	

	banksel	OSCCON		;interny oscilator 8MHz
  	movlw	b'01111001'	;b'01101001'
     	movwf	OSCCON
        
     	banksel ANSEL		; I/O digitalne
	movlw 	b'00000000'
	movwf	ANSEL
	clrf	ANSELH
	
	; **********I2C ************
	
	 banksel	TRISC
  ;     	MOVLW   	B'11111111'      ; vechny vvody PORTU C vstupy
       	bsf	TRISC,3
       	bsf	TRISC,4
       	
        	banksel		SSPCON2
       	 MOVLW   	B'01100000'
        	MOVWF   	 SSPCON2
       	MOVLW  	 0x10		; 400kHz pri 4MHz osc --- ; (Fosc / (4 * penosov rychlost)) - 1
       	MOVWF  	 SSPADD           ; nastaven rychlosti komunikacie (napr 0x06 400khz I2C pro krystal 10Mhz ) datashhhet SSPADD 
        	BCF     	SSPSTAT,CKE      ; nastaven specifikace I2C
        	BSF     	SSPSTAT,SMP      ; data jsou vzorkovna po odesln vstupnch dat
        	BCF     	STATUS,RP0       ; banka 0
        	MOVLW   	0x38
        	MOVWF  	 SSPCON           ; nastaven I2C master mode
        	
        	
;     	BCF     	PIR1,7     	 ; vynulovat pznak ten-zpisu PSPIF 
      	BCF    	 PIR1,SSPIF       ; vynulovat pznak dokonen
       	BCF     	PIR2,BCLIF       ; vynulovat pznak kolize
;   	CLRF    	INTCON           ; dn peruen ani timery
        
; ************** nadstavenie PWM ************
	
	movlw	b'11111110'	; nadstavenie TMR2
	banksel	T2CON
	movwf	T2CON		; delic po 1:16, TMR2 povoleny, preddelic 1:4
	
	movlw	b'11111111'	; b'10011100' --- 100Hz ; b'01000000'
	banksel	PR2		;register periody TIMER2, perioda PWM
	movwf	PR2	
	

	 

	banksel	CCP2CON		; reg. pre moduly CCP2 -  RC1
	movlw	b'00011100'
	movwf	CCP2CON		; frekvencia pre PWM
	
	

			
;	movlw	0x10
;	movwf	CCPR2L	; velkost striedy
	
	banksel	0
        
        ; mazanie registrov 
       	clrf	dataI2C		; nacitane data z jedneho  I2C	
       	clrf	ee1
       	clrf	ee2
       	
       	clrf	R21
       	clrf	R22
       	clrf	R23
       	clrf	R24
       	
       	clrf	R31
       	clrf	R32
       	clrf	R33
       	clrf	R34
       	bcf	PORTD,1
       	bcf	PORTC,2
    	
    	movlw	0x22		; (22h) 8 stabilizanch meran- 16 pre oba PT100 + 16 pre test = 32meran + 2 na druh riadok LCD
    	movwf	cx
       	
       	movlw	0x80		; prv riadok LCD zaiatok 
       	movwf	cxLCD
       	
       	movlw	0x14		; register pre as zapnutia MAX vkonu  20x --- hodnotu treba nadstavi aj v testy.inc !!!!!!!! riadok cca 450 +
      	movwf	cccON		; nves PWM_ON20,40,60,80
      	movlw	0x0f		; register pre as vypnutia MAX vkonu  15 x --- hodnotu treba nadstavi aj v testy.inc !!!!!!!! riadok cca 420	+
      	movwf	cccOFF		; nves PWM_ON20,40,60,80
       	
       	
       	
       	
       	
       	
       	; ************** preventvne vypnutie PWM **********
       	
       	BSF 	PCLATH,4         
 	BCF 	PCLATH,3  
 	
       	call 	PWM_OFF
       	
       	; **********************************************
       	; natanie MAX teploty z EEPROM 
       	BSF 	PCLATH,4         
 	BSF 	PCLATH,3
 	
 	call	citEEPROM
       	
       	BCF 	PCLATH,4         
 	BCF 	PCLATH,3
       	; ****************************
	
;	BANKSEL	PORTA
	
;	bcf	PORTA,0		; RA0 = 0 - zapnutie Vref 4,096V
	

	; ************** inicializcia LCD ********
	
	call 	INILCD		; inicializacia LCD
	call	pauza0.2s


	
	
	movlw	b'00000001'		; CLEAR
	call	WRPRI
	nop
	;  ****************  natanie mat. kontanty x ********
	call	ref_float			;  x pre vpoet referennch hodnt pre16 bit prevod a 4,096V
					; tento vpoet sa men v zvislosti od U ref a to je momentalne 4,096V
	
	
	; ***************  I2C obsluha + vytanie adresy z IO ***************
;	call	I2C_factory_adr	
;	call	I2C_new

loop
	
	; *********** zapnutie  U ref  koli zamedzeniu  tepelnho ovplyvnenia PT100 *****************
	
	BANKSEL	PORTA
		
	bcf	PORTA,0		; RA0 = 0 - zapnutie Uref 4,096V
	
	call	pauza15ms		; pauza 30 ms koli stabilizcii
	call	pauza15ms
	
	; ******************************************************************
;	bcf	INTCON,GIE	; zakazanie prerusenia
	; ****
	; ********************* vpoet teploty PT100/1  podla odporu na PT100 ***************************
	
PT100_1
		
	call	I2C_citanie_CH0 	; natanie prvho A/D z MCP3426 - CH0	

	call	Iref_float		; vpoet ref I z AD1 na odpore R1 = 100 ohm


		
	call	I2C_citanie_CH1 	;; natanie druhho A/D z MCP3426 - CH1
	
	; *********** vypnutie  U ref  koli zamedzeniu  tepelnho ovplyvnenia  PT100 *****************	
	BANKSEL	PORTA	
	bsf	PORTA,0		; RA0 = 1 - vypnutie Uref 4,096V
	; ********************************************************
	
	call	R2_float			; vpoet odporu na prvom idle PT100
	
    	call	zobraz_prv_riadok	; zobraz vypocitan teplotu z PT100 na LCD
    		
    	; ************** testy na ON/OFF  a PWM nadstavenej teploty**************
	BSF 	PCLATH,4         
 	BCF 	PCLATH,3  
    	call	test1			 ;prprava na testy pre PWM tepeln idlo PT100/1
    	; *********************************************
    	
			
;	goto 	loopx

	; *********** zapnutie  U ref  koli zamedzeniu  tepelnho ovplyvnenia PT100 *****************
	
	BANKSEL	PORTA
		
	bcf	PORTA,0		; RA0 = 0 - zapnutie Uref 4,096V
	
	call	pauza15ms		; pauza 30 ms koli stabilizcii
	call	pauza15ms
	
	
	; ******************************************************************
	
PT100_2

;	call	pauza1s
	call	I2C_citanie_CH0 	; natanie prvho A/D z MCP3426 - CH0	

	call	Iref_float		; vpoet ref I z AD1 na odpore R1 = 100 ohm
	
	call	I2C_citanie_CH2 	;; natanie  A/D z MCP3421 v 16 bit mde
	
	; *********** vypnutie  U ref  koli zamedzeniu  tepelnho ovplyvnenia  PT100 *****************
	BANKSEL	PORTA	
	bsf	PORTA,0		; RA0 = 1 - vypnutie Uref 4,096V
	; ********************************************************
	

	call	R3_float			; vpoet odporu na druhom idle PT100
	
	call	zobraz_druh_riadok 	; zobraz vypocitan teplotu z PT100
	
	
	; ************** testy na ON/OFF  a PWM nadstavenej teploty**************
	BSF 	PCLATH,4         
 	BCF 	PCLATH,3  
    	call	test2			; prprava na testy pre PWM tepeln idlo PT100/1
    	; *********************************************
; *********************** ********
	
	; ****   povolenie prerusenia
;	pagesel 		loopx
;	banksel		INTCON
;	MOVLW	B'11001000'	; povolenie prerusenia od RB
;	MOVWF	INTCON
;	banksel		IOCB
;	bsf		IOCB,IOCB7	; povolenie RB7
	; ****
;	goto	loop
;loopx	
;	BANKSEL	PORTA
	bsf	PORTC,2	; svieti zelen LED
;	bcf	PORTC,2
	call	pauza0.2s	; pozor tto pauza obsahuje aj test tlatka na nadstavenie MAX teploty
;	call	pauza0.2s	; pozor tto pauza obsahuje aj test tlatka na nadstavenie MAX teploty
	
;	bcf	PORTD,1
;	bsf	PORTC,2
;	call	pauza0.2s	; pozor tto pauza obsahuje aj test tlatka na nadstavenie MAX teploty
;	call	pauza0.2s	; pozor tto pauza obsahuje aj test tlatka na nadstavenie MAX teploty
	
	goto	loop
	
	
	

; ******************* podprogramy II 

	include	"resistancia PT100.inc"	;vypoet teploty z nameranho odporu na PT100
;	include	"math_floatFP24.inc "	; desatinne cisla rutina + - / * na 24bit
	include	"testy.inc"		; TESTY A SPNANIE OHREVU + PWM
	include	"diferencia.inc"		; odstrnenie  vkyvov na meraniach
	include	"floasc.inc"		; prevod 32bit float na ASCII pre LCD
	
	include	"prerusenie.inc"		; rutina prerusenia  na nadstavenie MAX teploty v peci 
					;+ prevod BIN DEC na  + EEPROM OBSLUHA
	END
	