
; vypocet rezistancie povodn projekt D:\PICTEST\887\PEC na DPS\PT100test\resistancia\3.c
; sbory 2.c + 3.hex
; hotov sbor D:\PICTEST\887\PEC na DPS\resistancia.inc
; ********************* Matematick vpoty s desatinnou iarkou - FLOAT *******************************

;**********************************************************************************************
;**********************************************************************************************


;       All arguments to the routines in the math library are passed through the locations

;		AEXP,AARGB0,AARGB1,AARGB2,AARGB3

;		BEXP,BARGB0,BARGB1,BARGB2,BARGB3

;	with the result in

;		AEXP,AARGB0,AARGB1,AARGB2,AARGB3

;	Fixed point operands are left justified to xARGB0 and do not use xEXP. Floating point
;	operands have the biased exponent in xEXP, followed by the normalized fraction left
;	justified to xARGB0 with its implicit MSB replaced by the sign bit.

;**********************************************************************************************

;	To divide the floating point number 0x823C5198 by 0x7ED3A57F, load the values into
;	AARG and BARG and call FPD32. The unrounded floating point result, 0x82E3C899, is
;	returned in AEXP,AARGB0,AARGB1,AARGB2, with the next significant byte, 0xE3 in AARGB3.
; ********************************************************************************

; vpoet x - najmeniehi dielika mV danho rozsahu napr pri Uref 4.096 ---  x = 4,096/65535 = 6,25E-5
; vpoet Iref pre dalie vpoty teplt PT100  Iref =(x*AD1)/R1

ref_float		; prv slo
		MOVLW	0x80		;4.096  ---  81 03 12 6F
		MOVWF	AEXP		; 2.048  ---  80 03 12 6F
		MOVLW	0x03
		MOVWF	AARGB0
		MOVLW	0x012
		MOVWF	AARGB1
		MOVLW	0x6f
		MOVWF	AARGB2
		; druh slo
		MOVLW	0x8e		;65535  ---   8E 7F FF 00
		MOVWF	BEXP		; 32768 ---   85 00 00 00 
		MOVLW	0x7f
		MOVWF	BARGB0
		MOVLW	0xff
		MOVWF	BARGB1
		MOVLW	0x00
		MOVWF	BARGB2
		
		
;		CALL    FLO32
		
;		 CALL    INT32

		CALL	FPD32		; deleno 
;		call	FPS32 

		; uloenie kontanty x (float) pre budce vpoty
		
		movfw	AEXP
		movwf	x1
		movfw	AARGB0
		movwf	x2
		movfw	AARGB1
		movwf	x3
		movfw	AARGB2
		movwf	x4
		
		return

	; *** Iref ....   Iref= (AD1*x)/R1		
Iref_float		
		; prevod 16 bit A/D na 32 bit flotat
		
;		; prv slo	
		clrf		AEXP		; 16 bit AD1
		clrf		AARGB0
		MOVFW	AD1_HI
		MOVWF	AARGB1
		MOVFW	AD1_LO
		MOVWF	AARGB2
		
		CALL    FLO32			; prevod 16bit na 32bit float
		
		; *********** natanie AD1 prevodu do zlohy pre kalibrciu ***********
		movfw		AEXP
		movwf		AD1_11	
		movfw		AARGB0
		movwf		AD1_12	
		movfw		AARGB1
		movwf		AD1_13	
		movfw		AARGB2
		movwf		AD1_14
		; ***********************************************************
		
		; druh slo
		MOVFW	x1		; x 
		MOVWF	BEXP
		MOVFW	x2
		MOVWF	BARGB0
		MOVFW	x3
		MOVWF	BARGB1
		MOVFW	x4
		MOVWF	BARGB2
		
		
		
		CALL	FPM32 			; nsobenie (AD1*x)
		
		; druh slo
			
		MOVLW	0x85		; R1- 100ohm  je nemenn kontanta   100 = 85 48 00 00 FLOAT	
		MOVWF	BEXP
		MOVLW	0x48
		MOVWF	BARGB0
		MOVLW	0x00
		MOVWF	BARGB1
		MOVLW	0x00
		MOVWF	BARGB2
		
		CALL		FPD32 	; delenie 
		
		
		; *************** R = R*1,199 ********************** 
;
;		MOVLW	0x7e		;   	
;		MOVWF	BEXP
;		MOVLW	0x7f
;		MOVWF	BARGB0
;		MOVLW	0xdf
;		MOVWF	BARGB1
;		MOVLW	0x3b
;		MOVWF	BARGB2
	; ***********************************
	
;		BCF 	PCLATH,4         
  ;  		BCF 	PCLATH,3
	
;		call	FPM32 		;R*1,2
			
		; uloenie kontanty Iref (float) pre budce vpoty
		movfw	AEXP
		movwf	Iref1
		movfw	AARGB0
		movwf	Iref2
		movfw	AARGB1
		movwf	Iref3
		movfw	AARGB2
		movwf	Iref4
		
		return
		
		
; ******************* vpoty odporov na idlch PT100


R2_float				; prv idlo R2 = ( AD2 * x) / Iref
	
	
		
;		; prv slo, prevod 16 bit A/D na 32 bit flotat	
		clrf		AEXP		; 16 bit AD2
		clrf		AARGB0
		MOVFW	AD2_HI
		MOVWF	AARGB1
		MOVFW	AD2_LO
		MOVWF	AARGB2
		
		CALL    FLO32			; prevod 16bit na 32bit float
		
		; ********** tepeln kompenzcia na cidle PT100/2 *****
		; ********** kalibran kontanta
		; ****************AD = AD-AD1 ********************************* R2 - horn 
				
		MOVFW	AD1_11		;   	
		MOVWF	BEXP
		MOVLW	AD1_12
		MOVWF	BARGB0
		MOVLW	AD1_13
		MOVWF	BARGB1
		MOVLW	AD1_14
		MOVWF	BARGB2

	
;		BCF 	PCLATH,4         
;    		BCF 	PCLATH,3
;	
		call	FPS32   		; AD  - AD1		
		
		; *************** AD = AD*1,0003 ********************** R2 -horn 

		MOVLW	0x7f		;   	
		MOVWF	BEXP
		MOVLW	0x07
		MOVWF	BARGB0
		MOVLW	0x6c8b
		MOVWF	BARGB1
		MOVLW	0x14
		MOVWF	BARGB2
	
;		BCF 	PCLATH,4         
  ;  		BCF 	PCLATH,3
	
		call	FPM32 		;AD*1.0003
	; ***************************************************	
	; ****************AD = AD+AD1 ********************************* R2 - horn
				
		MOVFW	AD1_11		;   	
		MOVWF	BEXP
		MOVLW	AD1_12
		MOVWF	BARGB0
		MOVLW	AD1_13
		MOVWF	BARGB1
		MOVLW	AD1_14
		MOVWF	BARGB2
	
;		BCF 	PCLATH,4         
;    		BCF 	PCLATH,3
;	
		call	FPA32   		; AD  + AD1
	
	
	; ***********************************************
	; **************************************************
	; *************** AD/10 ******** jedn sa o idlo PT1000  !!!!!! *******
	
		MOVLW	0x82		;   	
		MOVWF	BEXP
		MOVLW	0x20
		MOVWF	BARGB0
		MOVLW	0x00
		MOVWF	BARGB1
		MOVLW	0x00
		MOVWF	BARGB2
	
;		BCF 	PCLATH,4         
  ;  		BCF 	PCLATH,3
	
		call	FPD32 		;AD/10
	
		
		; druh slo
		MOVFW	x1		; x 
		MOVWF	BEXP
		MOVFW	x2
		MOVWF	BARGB0
		MOVFW	x3
		MOVWF	BARGB1
		MOVFW	x4
		MOVWF	BARGB2
		
		CALL	FPM32 			; nsobenie (AD2*x)
		
		; druh slo
			
		MOVFW	Iref1		;  / Iref	
		MOVWF	BEXP
		MOVFW	Iref2
		MOVWF	BARGB0
		MOVFW	Iref3
		MOVWF	BARGB1
		MOVFW	Iref4
		MOVWF	BARGB2
		
		CALL		FPD32 	; delenie 
		
		
		
		
	; *******  prava odporu na spravnu hodnotu  R = (R+R2)/2  prava zklmitu ****  spriemerovanie dvoch poslednch meran ****
;		clrf	PCLATH
		BSF 	PCLATH,4         
    		BCF 	PCLATH,3  
		
		call	upravaR2		; R = (R+R2)/2
		
		
		
; *******************************************************
 	

		; ************************ matematick vpoet teploty z danho odporu  *******************************
		;  ********* prava vslednho sal v tvare float 32bit MICROCHIP na float 32bt IEEE 754 *******
		; ********* lebo dalia vpoty s roben z C a to pota v tavre IEEE 754 *********************
		
		 RLF AARGB0,F
		 RRF AEXP,F
		 RRF AARGB0,F
		; *****************************
	
		; ********************* vpoet aktulnej teploty ********************************
		; ****** udva sa v 24bit tvare, posledn bit sa nahrdza vo vpotoch 00, lebo ovplyvuje ****
		; ******  chybu a na 4 tom miesta za desatinnou iarkou a to ns nezaujma  *************
	
		; ******************  vstup nameran odpor na PT100 idle 
   		 MOVFW 	AARGB1      ;   b'00110011'  d'051'  "3"  ***** 33	L
   	 	MOVWF	 LRAM_0x23
    		MOVFW 	AARGB0       ;   b'11001000'  d'200'      ****** c8	M
   		 MOVWF 	LRAM_0x24
   		MOVFW  	AEXP      ;   b'01000010'  d'066'  "B" ***** 42 	H
    		MOVWF 	LRAM_0x25
    		; **************************************
    	
    	; *************** matematick vpoet teploty z danho odporu  ***********************
    		BCF 	PCLATH,4         
    		BSF 	PCLATH,3   
    	   
    		call	resistPT100		; matematick vpoet teploty z danho odporu 
	; *************************************
	
		; ******************  vstup nameran odpor na PT100 idle 
   		 MOVFW 	LRAM_0x26    ;   	L
   	 	MOVWF	 AARGB1
    		MOVFW 	LRAM_0x27     ;  	M
   	 	MOVWF 	AARGB0
   		MOVFW  	LRAM_0x28   ;   	H
    		MOVWF 	AEXP 
    		;  *****************************************
    	
		;  ********* prava vslednho sal v tvare  float 32bt IEEE 754 na float 32bit MICROCHIP   ******************
		; ********* lebo dalia vpoty s roben z ASM a to pota v tavre float 32bit MICROCHIP *********************
		
	 	RLF AARGB0,F
		RLF AEXP,F
	 	RRF AARGB0,F
		; *****************************		
	
	; *********** prevod float 32bit MICROCHIP na 16 bit hex
		BSF	PCLATH,4         
 		BCF 	PCLATH,3  
    		
		CALL    float_ascii			; 
	
	
	
;		call 	vypocet_PT100
		
		; uloenie kontanty R2 (float) pre budce vpoty
;		movfw	AEXP
;		movwf	R21
;		movfw	AARGB0
;		movwf	R22
;		movfw	AARGB1
;		movwf	R23
;		movfw	AARGB2
;		movwf	R24
		
		 
	return
	
	
R3_float				; druh idlo R3 = ( AD3 * x) / Iref

	
		; prv slo, prevod 16 bit A/D na 32 bit flotat	
		clrf		AEXP		; 16 bit AD3
		clrf		AARGB0
		MOVFW	AD3_HI
		MOVWF	AARGB1
		MOVFW	AD3_LO
		MOVWF	AARGB2
		
		CALL    FLO32			; prevod 16bit na 32bit float
		
		
		; ********** tepeln kompenzcia na cidle PT100/3 *****
		; ********** kalibran kontanta
		; ****************AD = AD-AD1 ********************************* R3 - doln 
				
		MOVFW	AD1_11		;   	
		MOVWF	BEXP
		MOVLW	AD1_12
		MOVWF	BARGB0
		MOVLW	AD1_13
		MOVWF	BARGB1
		MOVLW	AD1_14
		MOVWF	BARGB2

	
;		BCF 	PCLATH,4         
;    		BCF 	PCLATH,3
;	
		call	FPS32   		; AD  - AD1		
		
		; *************** AD = AD*1,04 ********************** R3 -doln

	MOVLW	0x7f		;   	
	MOVWF	BEXP
	MOVLW	0x08
	MOVWF	BARGB0
	MOVLW	0x93
	MOVWF	BARGB1
	MOVLW	0x75
	MOVWF	BARGB2
	
;		BCF 	PCLATH,4         
  ;  		BCF 	PCLATH,3
	
	call	FPM32 		;AD*1,04
	; ***************************************************	
	; ****************AD = AD+AD1 ********************************* R3 -doln
				
		MOVFW	AD1_11		;   	
		MOVWF	BEXP
		MOVLW	AD1_12
		MOVWF	BARGB0
		MOVLW	AD1_13
		MOVWF	BARGB1
		MOVLW	AD1_14
		MOVWF	BARGB2

	
;		BCF 	PCLATH,4         
;    		BCF 	PCLATH,3
;	
		call	FPA32   		; AD  + AD1
	
	; **************************************************
		; **************************************************
	; *************** AD/10 ******** jedn sa o idlo PT1000  !!!!!! *******
	
	MOVLW	0x82		;   	
	MOVWF	BEXP
	MOVLW	0x20
	MOVWF	BARGB0
	MOVLW	0x00
	MOVWF	BARGB1
	MOVLW	0x00
	MOVWF	BARGB2
	

	
	call	FPD32 		;AD/10
		
		
		; druh slo
		MOVFW	x1		; x 
		MOVWF	BEXP
		MOVFW	x2
		MOVWF	BARGB0
		MOVFW	x3
		MOVWF	BARGB1
		MOVFW	x4
		MOVWF	BARGB2
		
		CALL	FPM32 			; nsobenie (AD3*x)
		; **********************************************************
		; druh slo
			
		MOVFW	Iref1		;  / Iref	
		MOVWF	BEXP
		MOVFW	Iref2
		MOVWF	BARGB0
		MOVFW	Iref3
		MOVWF	BARGB1
		MOVFW	Iref4
		MOVWF	BARGB2
		
		CALL		FPD32 	; delenie
		
		
; *******  prava odporu na spravnu hodnotu  R = (R+R2)/2  prava zklmitu ****  spriemerovanie dvoch poslednch meran ****
;		clrf	PCLATH
		BSF 	PCLATH,4         
    		BCF 	PCLATH,3  
		
		call	upravaR3		; R = (R+R2)/2
		
; *******************************************************
		
		; ************************ matematick vpoet teploty z danho odporu  *******************************
		;  ********* prava vslednho sal v tvare float 32bit MICROCHIP na float 32bt IEEE 754 *******
		; ********* lebo dalia vpoty s roben z C a to pota v tavre IEEE 754 *********************
		
		 RLF AARGB0,F
		 RRF AEXP,F
		 RRF AARGB0,F
		; *****************************
	
		; ********************* vpoet aktulnej teploty ********************************
		; ****** udva sa v 24bit tvare, posledn bit sa nahrdza vo vpotoch 00, lebo ovplyvuje ****
		; ******  chybu a na 4 tom miesta za desatinnou iarkou a to ns nezaujma  *************
	
		; ******************  vstup nameran odpor na PT100 idle 
   		 MOVFW 	AARGB1      ;   b'00110011'  d'051'  "3"  ***** 33	L
   	 	MOVWF	 LRAM_0x23
    		MOVFW 	AARGB0       ;   b'11001000'  d'200'      ****** c8	M
   		 MOVWF 	LRAM_0x24
   		MOVFW  	AEXP      ;   b'01000010'  d'066'  "B" ***** 42 	H
    		MOVWF 	LRAM_0x25
    		; **************************************
    	
    	; *************** matematick vpoet teploty z danho odporu  ***********************
    		BCF 	PCLATH,4         
    		BSF 	PCLATH,3   
    	   
    		call	resistPT100		; matematick vpoet teploty z danho odporu 
	; *************************************
	
		; ******************  vstup nameran odpor na PT100 idle 
   		 MOVFW 	LRAM_0x26    ;   	L
   	 	MOVWF	 AARGB1
    		MOVFW 	LRAM_0x27     ;  	M
   	 	MOVWF 	AARGB0
   		MOVFW  	LRAM_0x28   ;   	H
    		MOVWF 	AEXP 
    		;  *****************************************
    	
		;  ********* prava vslednho sal v tvare  float 32bt IEEE 754 na float 32bit MICROCHIP   ******************
		; ********* lebo dalia vpoty s roben z ASM a to pota v tavre float 32bit MICROCHIP *********************
		
	 	RLF AARGB0,F
		RLF AEXP,F
	 	RRF AARGB0,F
		; *****************************
		
		
	
	
	; *********** prevod float 32bit MICROCHIP na 16 bit hex
		BSF 	PCLATH,4         
   		BCF 	PCLATH,3   
    		
		CALL    float_ascii


	return




		
	
	
	
