;*********************************************************************
;
;	cakacie doby pri freq. 4MHz
;
;*********************************************************************

;************************ pauza 5s

;pauza5s			;5000000 cycles
;	movlw	0x2D
;	movwf	d1
;	movlw	0xE7
;	movwf	d2
;	movlw	0x0B
;	movwf	d3
;Delay_5s
;	decfsz	d1, f
;	goto	$+2
;	decfsz	d2, f
;	goto	$+2
;	decfsz	d3, f
;	goto	Delay_5s
;	return
	
;******************* pauza 2s	
;pauza2s
			;1999996 cycles
;	movlw	0x11
;	movwf	d1
;	movlw	0x5D
;	movwf	d2
;	movlw	0x05
;	movwf	d3
;Delay_2s
;	decfsz	d1, f
;	goto	$+2
;	decfsz	d2, f
;	goto	$+2
;	decfsz	d3, f
;	goto	Delay_2s

			;4 cycles
;	goto	$+1
;	goto	$+1
;	return
;
;******************** pauza 1s

;pauza1s

			;999997 cycles
;	movlw	0x08
;	movwf	d1
;	movlw	0x2F
;	movwf	d2
;	movlw	0x03
;	movwf	d3
;Delay_1s
;	decfsz	d1, f
;	goto	$+2
;	decfsz	d2, f
;	goto	$+2
;	decfsz	d3, f
;	goto	Delay_1s

			;3 cycles
;	goto	$+1

;	return




;********************* pauza 0.5s


;pauza0.5s			;499994 cycles
;	movlw	0x03
;	movwf	d1
;	movlw	0x18
;	movwf	d2
;	movlw	0x02
;	movwf	d3
;Delay_0
;	decfsz	d1, f
;	goto	$+2
;	decfsz	d2, f
;	goto	$+2
;	decfsz	d3, f
;	goto	Delay_0

			;6 cycles
;	goto	$+1
;	goto	$+1
;	goto	$+1
;	return

;***************************** pauza 0.2s - ; pozor tto pauza obsahuje aj test tlatka na nadstavenie MAX teploty

pauza0.2s			;199998 cycles pri 4MHz!!!!!!!!!

	movlw	0x3F
	movwf	d1
	movlw	0x9D
	movwf	d2
Delay_0.2s
	decfsz	d1, f
	goto	$+2
	
		; test tlatka
	; ***********************
	banksel PORTA
	btfsc	PORTA,1	;enkder tlatko
	goto	pauza0.2s_skok
	; **************************
	
	decfsz	d2, f
	goto	Delay_0.2s

			;2 cycles
	goto	$+1
	return

pauza0.2s_skok
	; ******************************************	
	; program prerusenia, nadstavenie max teploty
	; ****************************************
	
	pagesel	prerus 
	call	prerus
	
	return	

;***************************** pauza 0.1s

pauza0.1s			;99998 cycles
	movlw	0x1F
	movwf	d1
	movlw	0x4F
	movwf	d2
Delay_0.1s
	decfsz	d1, f
	goto	$+2
	decfsz	d2, f
	goto	Delay_0.1s

			;2 cycles
	goto	$+1
	return
		
;******************************* pauza 15ms
pauza15ms
		; Delay = 0.017 seconds
		; Clock frequency = 4 MHz

		; Actual delay = 0.017 seconds = 17000 cycles
		; Error = 0 %

		;************** premenne
		;	cblock
		;	p1
		;	p2
		;	endc
		;******************************************
		
	
			;16998 cycles
	movlw	0x47
	movwf	d1
	movlw	0x0E
	movwf	d2
Delay_15
	decfsz	d1, f
	goto	$+2
	decfsz	d2, f
	goto	Delay_15


	goto	$+1		;2 cycles
	return
	
; ******************************** pauza 5ms ********************

pauza5ms

			;4998 cycles
	movlw	0xE7
	movwf	d1
	movlw	0x04
	movwf	d2
Delay_5
	decfsz	d1, f
	goto	$+2
	decfsz	d2, f
	goto	Delay_5

			;2 cycles
	goto	$+1
	return
	
	
;************** pauza 1.6ms *********************

;pauza1.6ms			;1598 cycles
;	movlw	0x3F
;	movwf	d1
;	movlw	0x02
;	movwf	d2
;Delay_1.6
;	decfsz	d1, f
;	goto	$+2
;	decfsz	d2, f
;	goto	Delay_1.6

			;2 cycles
;	goto	$+1

;	return

;************** pauza 1,2ms ********************************	


pauza1ms
			;1198 cycles
	movlw	0xEF
	movwf	d1
	movlw	0x01
	movwf	d2
Delay_1
	decfsz	d1, f
	goto	$+2
	decfsz	d2, f
	goto	Delay_1

			;2 cycles
	goto	$+1
	return
	
	
;******************* pauza 0.5 ms

;pauza0.5ms			;499 cycles
;	movlw	0xA6
;	movwf	d1
;Delay_0.5
;	decfsz	d1, f
;	goto	Delay_0.5

			;1 cycle
;	nop

;	return
	

	

;*********************** pauza 550 us

;pauza550us			;550 cycles
;	movlw	0xB7
;	movwf	d1
;Delay_550us
;	decfsz	d1, f
;	goto	Delay_550us
	
;	return
	
;********************** pauza 250 us

; Actual delay = 0.00025 seconds = 250 cycles
; Error = 0 %

;pauza250us
			;250 cycles
;	movlw	0x53
;	movwf	d1
;Delay_250us
;	decfsz	d1, f
;	goto	Delay_250us
	
;	return
	
; ****************** pauza 50us

;pauza50us			;49 cycles
;	movlw	0x10
;	movwf	d1
;Delay_50us
;	decfsz	d1, f
;	goto	Delay_50us

			;1 cycle
;	nop
;	return
	
;******************* pauza 1us


;pauza10us			;10 cycles
;	goto	$+1
;	goto	$+1
;	goto	$+1
;	goto	$+1
;	goto	$+1

;	return
