


; **********************************************************
; **************  program preruenia  ******************
; ********** nadstav sa MAX teplota v peci ****************
; **********************************************************

	org	0x1800	;60145  ,   PCLATH	= 11

prerus

	       	; ************** preventvne vypnutie PWM **********
       	
       	BSF 	PCLATH,4         
 	BCF 	PCLATH,3  
 	
       	call 	PWM_OFF
       	
       	; ***********************************************

	BCF 	PCLATH,4         
 	BCF 	PCLATH,3
	
	movlw	b'00000001'
	call	WRPRI	
	
	movlw	0x4D		;  M
	call	WRDATA
	
	movlw	0x41		; A
	call	WRDATA
	
	movlw	0x58		; X
	call	WRDATA
	
	movlw	0x20		;  
	call	WRDATA
	
	movlw	0x54		; T
	call	WRDATA
	
	
	movlw	0x45		; E
	call	WRDATA
	
	
	
	movlw	0x4D		; M
	call	WRDATA
	
	movlw	0x50		; P
	call	WRDATA
	
	; druh riadok 
	
	movlw	b'10101000'
	call	WRPRI
	
	movlw	0x20		;*
	call	WRDATA
	
	movlw	0x20		;*
	call	WRDATA
	
	movlw	0x20		;*
	call	WRDATA
	
	movlw	0x20		;*
	call	WRDATA
	
	movlw	0x20		;*
	call	WRDATA
	
	movlw	0xb2		;
	call	WRDATA
	
	movlw	0x43		;C
	call	WRDATA
	
	movlw	0x20		;*
	call	WRDATA
	
	
	
	BSF 	PCLATH,4         
 	BSF 	PCLATH,3
 	
 
 	;***************** zobraz hodnotu MAX na LCD *******
	movfw	MAX
	movwf	TEMPNM
	call	RADaa		
	call	zobraz_MAX
	
	; ************ test neustle stlaenho tlatka ***********
	banksel PORTA
	btfsc	PORTA,1	;enkder tlatko
	goto	$-2
	; ******************
	;  ****************** program nadstavenia MAX teploty ***************
max_t	
	; ******* nadstavenie vstupov *********
	banksel	TRISB
	bsf	TRISB,7
	bsf	TRISB,6
	banksel	PORTB
	; ******* nadstavenie vstupov *********
	
	btfsc	PORTB,7
	goto	nadstavMAX_t		;
max_koniec	
	; *********** nvrat naspe to programu ***************
	banksel PORTA
	btfss	PORTA,1	;enkder tlatko
	goto	max_t	
	; **************************************************	
	
	banksel PORTA		; ak je stlaen tlatko pokaj na uvolnenie
	btfsc	PORTA,1	;enkder tlatko
	goto	$-2
	
	; ********************* zpis hodnoty MAX teploty do EEPROM  *********************
	movfw		MAX
	banksel		EEDATA
	MOVWF 	EEDATA		;data na zapis do EEPRO
	 
	 call		zapEEPROM
	 
	 
	
	
	
	BCF 	PCLATH,4         
 	BCF 	PCLATH,3
 	
 	movlw	b'00000001'			; LCD reset
	call	WRPRI	
 	
;	goto	$-1
	return
	
; *******************************************************************************
; **************** obslun rutiny **************************************************
; *******************************************************************************	
	
test_nvrat	
	; *********** nvrat naspe to programu ***************
	banksel PORTA
	btfss	PORTA,1	;enkder tlatko
	return
	; **************************************************
	
	; ********** samotn nadstavenie hodnoty MAY teploty ********
nadstavMAX_t
	
	
	; ************************ rozhodovanie podla enkodera *******
	; ******* ak je A=1 a hned B=0 - jedna strana ( neskor po7 - 15 ms A=1  B=1 o trv cca  5-12 ms, tieto hodnoty s v zvislosti rchlosti otania)  // najprv A=0 1,5-3 ms potom B=0 !!!!!! //
	; ******  ak je A=0 a hned B=1 druha strana  (cca7 - 15 ms A=1 B=1 **********  // potom najprv  B= 0  1,5-3ms potom A=0 !!!!!! ///	
;	call	enk_pauza550us

enk_test	
	btfsc	PORTB,7		;ak sa zmen RB7 z 1 na 0, tak porovnaj o je na RB6 a podla toho zv/zn hodnotu
	goto	test_navrat2
	
	btfss	PORTB,6
	goto	nadstavMAX_thore
	goto	nadstavMAX_tdole

	; *******************
test_navrat2		; test tlatka MENU kli zacyklovaniu
	call	test_nvrat
	goto	enk_test
;	goto	max_t
	; ****************
	
; ******************************************************

nadstavMAX_tdole

	; ***** ochrana pred zkmitom *******
	call	enk_pauza20us
	btfss	PORTB,6
	goto	enk_test
	
	; ******************************

	
	
	decf	MAX,f			; zmen hodnotu MAXimlnej teploty
	BNZ	pokracuj_dole		; ak je Z=0 pripotaj k MAX 1 a cho alej
	
	incf	MAX,f	
	
pokracuj_dole	

	;***************** zobraz hodnotu na LCD *******
	movfw	MAX
	movwf	TEMPNM
	call	RADaa		
	call	zobraz_MAX
		
	goto	max_t
	; ************************************************
nadstavMAX_thore

	; ***** ochrana pred zkmitom *******
	call	enk_pauza20us
	btfsc	PORTB,6
	goto	enk_test
	
	; ******************************


	incf	MAX,f			; zmen hodnotu MAXimlnej teploty
	BNZ	pokracuj_hore		; ak je Z=0 pripotaj k MAX 1 a cho alej
	
	decf	MAX,f	
	
pokracuj_hore	

	;***************** zobraz hodnotu na LCD *******
	movfw	MAX
	movwf	TEMPNM
	call	RADaa		
	call	zobraz_MAX
		
	goto	max_t
	; ************************************************


	; ********************* cakacia pauza pre enkoder  koli zakmitom **********************************
	
enk_pauza1ms			;1998 cycles

	movlw	0x8F
	movwf	d1
	movlw	0x02
	movwf	d2
Delay_0enk2
	decfsz	d1, f
	goto	$+2
	decfsz	d2, f
	goto	Delay_0enk2

			;2 cycles
	goto	$+1

	return

enk_pauza20us			;40 cycles
	movlw	0x0D
	movwf	d1
Delay_0enk
	decfsz	d1, f
	goto	Delay_0enk
	
	return
	
	
; ******************************  zobrazenie a LCD rutiny ***********************


; ========================================================================
;  Prevody binarni hodnoty  bin/ DEC
;	

         ; ========================================================================
;  

        
     ;  DEC na  kod celej teploty v ROM LCD aj ked
     ;   je to  mozne pocitat priamo z TEMPL a TEMPH bez predchadzajucej upravy !!!!!!
     ; 
     ;	org	0x1800
     	
RADaa
	movfw	TEMPNM		; ulozene DEC cislo celej teploty
  	movwf 	TMP_H 		; W -> TMP_L 
     	clrf 	CISLA100 
     	clrf 	CISLA10
     	clrf 	CISLA1
     	clrf	CISLA01	 
     ;------------------------------- 
RAD100 
     movlw 	.100 
     subwf 	TMP_H,W 
     btfss 	STATUS,C 
     goto 	RAD10 		; C=0, vysledek je zaporny konec odcitani 
     ; ------------------------ 
     movwf 	TMP_H 
     incf 	CISLA100,F 
     goto 	RAD100 
     ;-------------------------------
RAD10
     movlw 	.10 
     subwf 	TMP_H,W 
     btfss 	STATUS,C 
     goto 	RAD1 			    ; C=0, vysledek je zaporny konec odcitani 
     ; ------------------------ 
     movwf	 TMP_H 
     incf 	CISLA10,F 
     goto 	RAD10 
     ;------------------------------- 
RAD1 
     movlw 	.1 
     subwf 	TMP_H,W 
     btfss 	STATUS,C 
     goto 	RADx 			   ; C=0, vysleoek je zaporny konec odcitania 
     ; ------------------------ 
     movwf 	TMP_H 
     incf 	CISLA1,F 
     goto 	RAD1
     

RADx movfw	TEMPDP		; ulozene DEC cislo desatinnej hodnoty teploty 
     movwf 	TMP_H 	
     
     
RAD01 
     movlw 	.1 
     subwf 	TMP_H,W 
     btfss 	STATUS,C 
     goto 	RAD  			   ; C=0, vysledek je zaporny konec odcitania 
     ; ------------------------ 
     movwf 	TMP_H 
     incf 	CISLA01,F 
     goto 	RAD01
     
 
     ;------------------- uprava na ROM LCD
     ; k kazdemu cislu treba pricitat 48dec -> 30hex, pretoze
     ; prvych 48 adries v ROM kode su adresy pre vlastne definovane znaky
     ; a dalsich preddefinovane znaky a cisla zacinaju od adresy 48 ..... 
    
RAD    
 	movfw	CISLA100	;stovky na LCD
        addlw	0x30
        movwf	stovky
        
        movfw	CISLA10		;desiatky na LCD
        addlw	0x30
        movwf	desiatky
        
        movfw	CISLA1		;jednotky na LCD
        addlw	0x30
        movwf	jednotky 
        
;       movfw	CISLA01		;desatinne cislo na LCD
;       addlw	0x30
;        movwf	LCD01


      
        RETURN
        
        
       	; ****************** zobrazenie MAX teploty na LCD ******
       	
       	
zobraz_MAX
	
	; ********************************************
	BCF 	PCLATH,4         
    	BCF 	PCLATH,3 
	
	; ********************
	
	movlw	b'10101001'
	call	WRPRI
   
   	movfw	stovky
	call	WRDATA
		
	movfw	desiatky		;
	call	WRDATA
		
	movfw	jednotky		;
	call	WRDATA
	
	BSF 	PCLATH,4         
 	BSF 	PCLATH,3
 	
    	return
    	
    	
   ; *************************** EEPROM obslun rutiny *********************
   
   
         ; ***************** zapis EEPROM	
	
zapEEPROM
	

	

;	banksel		tempEEPROM
;	MOVFW 	tempEEPROM		;cele cislo na zapis
;	banksel		EEDATA
;	MOVWF 	EEDATA		;data na zapis do EEPRO
	
	banksel		EEADR		
	clrf		EEADR		;adresa  v EEPROM 00
	movfw		EEADR

	BANKSEL 	EECON1 		;
	BCF 		EECON1,EEPGD 	;eepgd = 0 ---- EEPROM
	BSF 		EECON1,WREN 	;povolenie zapisu
	nop
	pagesel 		zapEEPROM
	BCF 		INTCON,GIE 	;zakazanie preruseni
	BTFSC 		INTCON,GIE 	;test zakazania prerusenia
	GOTO		$-4
	;************ povinna rutina pre zapis do EEPROM
	MOVLW 	0x55		;
	MOVWF 	EECON2 		;zapis 55h
	MOVLW 	0xAA 		;
	MOVWF 	EECON2 		;zapis AAh
	BSF 		EECON1, WR 	;WR = 1 --- zahajenia zapisu do EEPROM
	;*****************************************
	
	
	
	pagesel 		zapEEPROM
	btfsc		EECON1,WR	;test ukonceniazapisu WR sa zmani na 0
	goto		$-3
	
; ********************************************************	

	banksel		EECON1
	BCF 		EECON1,WREN 	;zakaz zapisu do EEPROM
	
	BSF 		INTCON,GIE 	; povolemie preruseni
	banksel	0
	
;	banksel		EEEADR
;	incf		EEEADR,f	;adresa v EEPROM + 1	
	
	
	
;	pagesel	menu
        return
 ; ******************************************** citanie EEPROM *************************
 
citEEPROM
 	
	banksel		EEADR		
	clrf		EEADR		;adresa  v EEPROM 00

 	banksel		EECON1		;banka3 reg eecon
 	bcf		EECON1,EEPGD	; vyber FLASH/EEPROM 
 	bsf		EECON1,RD	;zaciatok citania
 	btfsc		EECON1,RD	; test bitu rd = 0 ukoncenie citania
 	goto 		$-1
 	
	banksel		EEDATA
 	movfw		EEDATA
	banksel	0
	movwf		MAX		; MAX teplota
 
 	
 	return
 	