

; ***********************************************************************************************
; ************** zobrazenie hlsen a teploty na LCD ****************************************************
; ***********************************************************************************************





; ************** prvy riadok *****************	
zobraz_prv_riadok

	; stabilizan maranie pri spusten 8x (16 pre oba kanly)
	decfsz	cx,f
	goto	stabil
	incf	cx,f
	; ********************
	
	movlw	b'00000011'
	call	WRPRI
	
	goto 	zobraz
	
	
	
; ************** druh riadok *****************	
zobraz_druh_riadok
	; stabilizan maranie pri spusten 8x (16 pre oba kanly)
	decfsz	cx,f
	return
	incf	cx,f
	; ********************
	
	movlw	b'10101000'
	call	WRPRI
	
	
	
	
zobraz	
	

	; ************ stovky ***********
	movfw	stovky		; vymazanie 0 na zatku LCD
	sublw	0x30
	BNZ	zobraz2
	
	movlw	0x20		; ak je Z  = 0 tak nevype znak
	call	WRDATA	; ak neni Z = 0 tak zobraz dan znak
	
	; *********** desiatky ******************
	movfw	desiatky			; vymazanie 0 na zatku LCD
	sublw	0x30
	BNZ	zobraz3
	
	movlw	0x20		; ak je Z  = 0 tak nevype znak
	call	WRDATA	; ak neni Z = 0 tak zobraz dan znak
	goto	zobraz4	



zobraz2
	
	movfw	stovky
	call	WRDATA
	
	
zobraz3	
	movfw	desiatky		;
	call	WRDATA
	
	
	
	
zobraz4	
	
	
	movfw	jednotky		;
	call	WRDATA
	
	movlw	0x2c		; ,
	call	WRDATA
	
	movfw	desatiny		;
	call	WRDATA
	
	movfw	stotiny		;
	call	WRDATA
	
	
	movfw	tisiciny		;
	call	WRDATA
	
	
	
	movlw	0x43		;C
	call	WRDATA
	
	
	
	
	return
	
	
; *************** stabilizan maranie po resete 8x koli nataniu premennch

stabil
	movfw	cxLCD
	call	WRPRI
	
	movlw	0x2A		;*
	call	WRDATA
	
	incf	cxLCD,f
	
	return
